Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Spotlight Class Reference

A light originating from a single point in space, and shining in a particular direction, with a cone-shaped falloff. More...

`#include "spotlight.h"`

Inheritance diagram for Spotlight:

## Public Member Functions
| Spotlight (const std::string &name)
virtual void | bind (GraphicsStateGuardianBase *gsg, const NodePath &light, int light_id)
void | clear_specular_color ()
| Clears a custom specular color setting, meaning that the specular color will now come from the color.
virtual TypeHandle | force_init_type ()
const LVecBase3 & | get_attenuation () const final
| Returns the terms of the attenuation equation for the light.
virtual int | get_class_priority () const
| Returns the relative priority associated with all lights of this class.
PN_stdfloat | get_exponent () const final
| For spotlights, returns the exponent that controls the amount of light falloff from the center of the spotlight.
PN_stdfloat | get_max_distance () const
const LColor & | get_specular_color () const final
| Returns the color of specular highlights generated by the light.
virtual TypeHandle | get_type () const
virtual bool | get_vector_to_light (LVector3 &result, const LPoint3 &from_object_point, const LMatrix4 &to_object_space)
| Computes the vector from a particular vertex to this light.
virtual PandaNode * | make_copy () const
| Returns a newly-allocated PandaNode that is a shallow copy of this one.
void | set_attenuation (const LVecBase3 &attenuation)
void | set_exponent (PN_stdfloat exponent)
void | set_max_distance (PN_stdfloat max_distance)
void | set_specular_color (const LColor &color)
virtual void | write (std::ostream &out, int indent_level) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
virtual void | xform (const LMatrix4 &mat)
| Transforms the contents of this PandaNode by the indicated matrix, if it means anything to do so.
Public Member Functions inherited from LightLensNode
| LightLensNode (const std::string &name, Lens *lens=new PerspectiveLens())
virtual Light * | as_light ()
| Cross-casts the node to a Light pointer, if it is one of the four kinds of Light nodes, or returns NULL if it is not.
virtual PandaNode * | as_node ()
| Returns the Light object upcast to a PandaNode.
virtual void | attrib_ref ()
| This is called when the light is added to a LightAttrib.
virtual void | attrib_unref ()
| This is called when the light is removed from a LightAttrib.
GraphicsOutputBase * | get_shadow_buffer (GraphicsStateGuardianBase *gsg)
| Returns the buffer that has been constructed for a given GSG, or NULL if no such buffer has (yet) been constructed.
LVecBase2i | get_shadow_buffer_size () const
int | get_shadow_buffer_sort () const
| Returns the sort of the shadow buffer to be created for this light source.
bool | has_specular_color () const
| Returns true if this light defines a specular color, false if the specular color is derived automatically from the light color.
bool | is_shadow_caster () const
void | mark_used_by_auto_shader () const
| Marks this light as having been used by the auto shader.
virtual void | output (std::ostream &out) const
void | set_shadow_buffer_size (const LVecBase2i &size)
void | set_shadow_caster (bool caster)
| Sets the flag indicating whether this light should cast shadows or not.
void | set_shadow_caster (bool caster, int buffer_xsize, int buffer_ysize, int sort=-10)
| Sets the flag indicating whether this light should cast shadows or not.
Public Member Functions inherited from Light
| Light (const Light &copy)
const LColor & | get_color () const
PN_stdfloat | get_color_temperature () const
int | get_priority () const
GeomNode * | get_viz ()
| Returns a GeomNode that may be rendered to visualize the Light.
bool | has_color_temperature () const
| Returns true if the color was specified as a temperature in kelvins, and get_color_temperature is defined.
virtual bool | is_ambient_light () const
| Returns true if this is an AmbientLight, false if it is some other kind of light.
void | set_color (const LColor &color)
void | set_color_temperature (PN_stdfloat temperature)
void | set_priority (int priority)
Public Member Functions inherited from Camera
| Camera (const Camera &copy)
| Camera (const std::string &name, Lens *lens=new PerspectiveLens())
int | cleanup_aux_scene_data (Thread *current_thread=Thread::get_current_thread())
| Walks through the list of currently-assigned AuxSceneData objects and releases any that are past their expiration times.
bool | clear_aux_scene_data (const NodePath &node_path)
void | clear_tag_state (const std::string &tag_state)
void | clear_tag_states ()
| Removes all associations established by previous calls to set_tag_state().
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
AuxSceneData * | get_aux_scene_data (const NodePath &node_path) const
DrawMask | get_camera_mask () const
BoundingVolume * | get_cull_bounds () const
const NodePath & | get_cull_center () const
DisplayRegion * | get_display_region (size_t n) const
ConstPointerTo< RenderState > | get_initial_state () const
const NodePath & | get_lod_center () const
PN_stdfloat | get_lod_scale () const
size_t | get_num_display_regions () const
const NodePath & | get_scene () const
ConstPointerTo< RenderState > | get_tag_state (const std::string &tag_state) const
const std::string & | get_tag_state_key () const
bool | has_tag_state (const std::string &tag_state) const
bool | is_active () const
void | list_aux_scene_data (std::ostream &out) const
| Outputs all of the NodePaths and AuxSceneDatas in use.
virtual bool | safe_to_flatten () const
| Returns true if it is generally safe to flatten out this particular kind of Node by duplicating instances, false otherwise (for instance, a Camera cannot be safely flattened, because the Camera pointer itself is meaningful).
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of Node by calling the xform() method, false otherwise.
void | set_active (bool active)
void | set_aux_scene_data (const NodePath &node_path, AuxSceneData *data)
void | set_camera_mask (DrawMask mask)
void | set_cull_bounds (BoundingVolume *cull_bounds)
void | set_cull_center (const NodePath &cull_center)
void | set_initial_state (const RenderState *state)
void | set_lod_center (const NodePath &lod_center)
void | set_lod_scale (PN_stdfloat value)
void | set_scene (const NodePath &scene)
void | set_tag_state (const std::string &tag_state, const RenderState *state)
void | set_tag_state_key (const std::string &tag_state_key)
Public Member Functions inherited from LensNode
| LensNode (const std::string &name, Lens *lens=nullptr)
bool | activate_lens (int index)
| An alternate way to call set_lens_active(index, true).
void | copy_lens (const Lens &lens)
| Sets up the LensNode using a copy of the indicated Lens.
void | copy_lens (int index, const Lens &lens)
| Copies the indicated lens into the specified slot.
bool | deactivate_lens (int index)
| An alternate way to call set_lens_active(index, false).
Lens * | get_lens (int index=0) const
| Returns a pointer to the particular Lens associated with this LensNode, or NULL if there is not yet a Lens associated.
bool | get_lens_active (int index) const
| Returns the active flag for the nth lens.
void | hide_frustum ()
| Disables the drawing of the lens's frustum to aid in visualization.
bool | is_in_view (const LPoint3 &pos)
| Returns true if the given point is within the bounds of the lens of the LensNode (i.e.
bool | is_in_view (int index, const LPoint3 &pos)
| Returns true if the given point is within the bounds of the lens of the LensNode (i.e.
void | set_lens (int index, Lens *lens)
| Sets the indicated lens.
void | set_lens (Lens *lens)
| Sets up the LensNode using this particular Lens pointer.
bool | set_lens_active (int index, bool active)
| Sets the active flag for the nth lens.
void | show_frustum ()
| Enables the drawing of the lens's frustum to aid in visualization.
Public Member Functions inherited from PandaNode
| PandaNode (const std::string &name)
void | add_child (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node.
virtual void | add_for_draw (CullTraverser *trav, CullTraverserData &data)
| Adds the node's contents to the CullResult we are building up during the cull traversal, so that it will be drawn at render time.
void | add_stashed (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node, directly as a stashed child.
void | adjust_draw_mask (DrawMask show_mask, DrawMask hide_mask, DrawMask clear_mask)
| Adjusts the hide/show bits of this particular node.
virtual void | apply_attribs_to_vertices (const AccumulatedAttribs &attribs, int attrib_types, GeomTransformer &transformer)
| Applies whatever attributes are specified in the AccumulatedAttribs object (and by the attrib_types bitmask) to the vertices on this node, if appropriate.
virtual ConstPointerTo< TransformState > | calc_tight_bounds (LPoint3 &min_point, LPoint3 &max_point, bool &found_any, const TransformState *transform, Thread *current_thread=Thread::get_current_thread()) const
| This is used to support NodePath::calc_tight_bounds().
void | clear_attrib (int slot)
| Removes the render attribute of the given type from this node.
void | clear_attrib (TypeHandle type)
void | clear_bounds ()
| Reverses the effect of a previous call to set_bounds(), and allows the node's bounding volume to be automatically computed once more based on the contents of the node.
void | clear_effect (TypeHandle type)
| Removes the render effect of the given type from this node.
void | clear_effects (Thread *current_thread=Thread::get_current_thread())
void | clear_state (Thread *current_thread=Thread::get_current_thread())
void | clear_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread())
void | clear_transform (Thread *current_thread=Thread::get_current_thread())
void | clear_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits off, indicating that the corresponding property may once again change on this node.
virtual PandaNode * | combine_with (PandaNode *other)
| Collapses this PandaNode with the other PandaNode, if possible, and returns a pointer to the combined PandaNode, or NULL if the two PandaNodes cannot safely be combined.
int | compare_tags (const PandaNode *other) const
| Returns a number less than 0, 0, or greater than 0, to indicate the similarity of tags between this node and the other one.
void | copy_all_properties (PandaNode *other)
| Copies the TransformState, RenderState, RenderEffects, tags, Python tags, and the show/hide state from the other node onto this one.
void | copy_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Makes another instance of all the children of the other node, copying them to this node.
PointerTo< PandaNode > | copy_subgraph (Thread *current_thread=Thread::get_current_thread()) const
| Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.
void | copy_tags (PandaNode *other)
| Copies all of the tags stored on the other node onto this node.
int | count_num_descendants () const
| Returns the number of nodes at and below this level.
virtual bool | cull_callback (CullTraverser *trav, CullTraverserData &data)
| This function will be called during the cull traversal to perform any additional operations that should be performed at cull time.
virtual PandaNode * | dupe_for_flatten () const
| This is similar to make_copy(), but it makes a copy for the specific purpose of flatten.
int | find_child (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated child node, if it is a child, or -1 if it is not.
int | find_parent (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.
int | find_stashed (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.
ConstPointerTo< RenderAttrib > | get_attrib (int slot) const
ConstPointerTo< RenderAttrib > | get_attrib (TypeHandle type) const
ConstPointerTo< BoundingVolume > | get_bounds (Thread *current_thread=Thread::get_current_thread()) const
| Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.
ConstPointerTo< BoundingVolume > | get_bounds (UpdateSeq &seq, Thread *current_thread=Thread::get_current_thread()) const
| This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.
BoundingVolume::BoundsType | get_bounds_type () const
PandaNode * | get_child (int n, Thread *current_thread=Thread::get_current_thread()) const
int | get_child_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).
Children | get_children (Thread *current_thread=Thread::get_current_thread()) const
DrawMask | get_draw_control_mask () const
DrawMask | get_draw_show_mask () const
ConstPointerTo< RenderEffect > | get_effect (TypeHandle type) const
ConstPointerTo< RenderEffects > | get_effects (Thread *current_thread=Thread::get_current_thread()) const
int | get_fancy_bits (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.
virtual int | get_first_visible_child () const
| Returns the index number of the first visible child of this node, or a number >= get_num_children() if there are no visible children of this node.
ConstPointerTo< BoundingVolume > | get_internal_bounds (Thread *current_thread=Thread::get_current_thread()) const
int | get_internal_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_into_collide_mask () const
virtual CollideMask | get_legal_collide_mask () const
int | get_nested_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_net_collide_mask (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all into_collide_mask() values set at CollisionNodes at this level and below.
DrawMask | get_net_draw_control_mask () const
| Returns the set of bits in get_net_draw_show_mask() that have been explicitly set via adjust_draw_mask(), rather than implicitly inherited.
DrawMask | get_net_draw_show_mask () const
| Returns the union of all draw_show_mask values–of renderable nodes only– at this level and below.
virtual int | get_next_visible_child (int n) const
| Returns the index number of the next visible child of this node following the indicated child, or a number >= get_num_children() if there are no more visible children of this node.
int | get_num_children (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_parents (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_stashed (Thread *current_thread=Thread::get_current_thread()) const
size_t | get_num_tags () const
ConstPointerTo< RenderAttrib > | get_off_clip_planes (Thread *current_thread=Thread::get_current_thread()) const
| Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.
PandaNode * | get_parent (int n, Thread *current_thread=Thread::get_current_thread()) const
Parents | get_parents (Thread *current_thread=Thread::get_current_thread()) const
ConstPointerTo< TransformState > | get_prev_transform (Thread *current_thread=Thread::get_current_thread()) const
PandaNode * | get_stashed (int n, Thread *current_thread=Thread::get_current_thread()) const
Stashed | get_stashed (Thread *current_thread=Thread::get_current_thread()) const
int | get_stashed_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).
ConstPointerTo< RenderState > | get_state (Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag_key (size_t i) const
void | get_tag_keys (vector_string &keys) const
| Fills the given vector up with the list of tags on this PandaNode.
ConstPointerTo< TransformState > | get_transform (Thread *current_thread=Thread::get_current_thread()) const
unsigned int | get_unexpected_change (unsigned int flags) const
| Returns nonzero if any of the bits in the input parameter are set on this node, or zero if none of them are set.
virtual int | get_unsafe_to_apply_attribs () const
| Returns the union of all attributes from SceneGraphReducer::AttribTypes that may not safely be applied to the vertices of this node.
virtual int | get_visible_child () const
| Returns the index number of the currently visible child of this node.
bool | has_attrib (int slot) const
bool | has_attrib (TypeHandle type) const
bool | has_dirty_prev_transform () const
bool | has_effect (TypeHandle type) const
virtual bool | has_selective_visibility () const
| Should be overridden by derived classes to return true if this kind of node has some restrictions on the set of children that should be rendered.
virtual bool | has_single_child_visibility () const
| Should be overridden by derived classes to return true if this kind of node has the special property that just one of its children is visible at any given time, and furthermore that the particular visible child can be determined without reference to any external information (such as a camera).
bool | has_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
bool | has_tags () const
virtual bool | is_ambient_light () const
| Returns true if this is an AmbientLight, false if it is not a light, or it is some other kind of light.
bool | is_bounds_stale () const
virtual bool | is_collision_node () const
| A simple downcast check.
bool | is_final (Thread *current_thread=Thread::get_current_thread()) const
virtual bool | is_geom_node () const
| A simple downcast check.
virtual bool | is_lod_node () const
| A simple downcast check.
bool | is_overall_hidden () const
virtual bool | is_renderable () const
| Returns true if there is some value to visiting this particular node during the cull traversal for any camera, false otherwise.
bool | is_scene_root () const
| Returns true if this particular node is known to be the render root of some active DisplayRegion associated with the global GraphicsEngine, false otherwise.
bool | is_under_scene_root () const
| Returns true if this particular node is in a live scene graph: that is, it is a child or descendent of a node that is itself a scene root.
void | list_tags (std::ostream &out, const std::string &separator="\n") const
| Writes a list of all the tag keys assigned to the node to the indicated stream.
void | ls (std::ostream &out, int indent_level) const
void | mark_bounds_stale (Thread *current_thread=Thread::get_current_thread()) const
| Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.
void | mark_internal_bounds_stale (Thread *current_thread=Thread::get_current_thread())
| Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.
void | prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state)
| Walks through the scene graph beginning at this node, and does whatever initialization is required to render the scene properly with the indicated GSG.
virtual bool | preserve_name () const
| Returns true if the node's name has extrinsic meaning and must be preserved across a flatten operation, false otherwise.
virtual void | r_prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state, GeomTransformer &transformer, Thread *current_thread)
| The recursive implementation of prepare_scene().
void | remove_all_children (Thread *current_thread=Thread::get_current_thread())
| Removes all the children from the node at once, including stashed children.
void | remove_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth child from the node.
bool | remove_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Removes the indicated child from the node.
void | remove_stashed (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth stashed child from the node.
bool | replace_child (PandaNode *orig_child, PandaNode *new_child, Thread *current_thread=Thread::get_current_thread())
| Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.
void | replace_node (PandaNode *other)
| Inserts this node into the scene graph in place of the other one, and removes the other node.
void | reset_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Resets the transform that represents this node's "previous" position to the same as the current transform.
virtual bool | safe_to_combine () const
| Returns true if it is generally safe to combine this particular kind of PandaNode with other kinds of PandaNodes of compatible type, adding children or whatever.
virtual bool | safe_to_combine_children () const
| Returns true if it is generally safe to combine the children of this PandaNode with each other.
virtual bool | safe_to_flatten_below () const
| Returns true if a flatten operation may safely continue past this node, or false if nodes below this node may not be molested.
virtual bool | safe_to_modify_transform () const
| Returns true if it is safe to automatically adjust the transform on this kind of node.
void | set_attrib (const RenderAttrib *attrib, int override=0)
| Adds the indicated render attribute to the scene graph on this node.
void | set_bound (const BoundingVolume *volume)
void | set_bounds (const BoundingVolume *volume)
| Resets the bounding volume so that it is the indicated volume.
void | set_bounds_type (BoundingVolume::BoundsType bounds_type)
void | set_effect (const RenderEffect *effect)
| Adds the indicated render effect to the scene graph on this node.
void | set_effects (const RenderEffects *effects, Thread *current_thread=Thread::get_current_thread())
void | set_final (bool flag)
void | set_into_collide_mask (CollideMask mask)
void | set_overall_hidden (bool overall_hidden)
void | set_prev_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
void | set_state (const RenderState *state, Thread *current_thread=Thread::get_current_thread())
void | set_tag (const std::string &key, const std::string &value, Thread *current_thread=Thread::get_current_thread())
void | set_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
void | set_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits on, indicating that the corresponding property should not change again on this node.
void | stash_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
bool | stash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
void | steal_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Moves all the children from the other node onto this node.
void | unstash_child (int stashed_index, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
bool | unstash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
void | write_recorder (BamWriter *manager, Datagram &dg)
| This method is provided for the benefit of classes (like MouseRecorder) that inherit from PandaMode and also RecorderBase.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (Texture) make_spot(int pixel_width
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type Spotlight.
Static Public Member Functions inherited from LightLensNode
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Light
static TypeHandle | get_class_type ()
static UpdateSeq | get_sort_seq ()
| Returns a global sequence number that is incremented any time any Light in the world changes sort or priority.
static void | init_type ()
Static Public Member Functions inherited from Camera
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type Camera.
Static Public Member Functions inherited from LensNode
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type LensNode.
Static Public Member Functions inherited from PandaNode
static PointerTo< PandaNode > | decode_from_bam_stream (vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on those bytes.
static DrawMask | get_all_camera_mask ()
static TypeHandle | get_class_type ()
static DrawMask | get_overall_bit ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type PandaNode.
static void | reset_all_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Visits all nodes in the world with the _dirty_prev_transform flag–that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0–and resets the _prev_transform to be the same as _transform.
static void | set_scene_root_func (SceneRootFunc *func)
| This is used by the GraphicsEngine to hook in a pointer to the scene_root_func(), the function to determine whether the node is an active scene root.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
static PN_stdfloat LColor LColor & | bg
static PN_stdfloat LColor & | fg
static PN_stdfloat | full_radius
| get_attenuation
| Returns the terms of the attenuation equation for the light.
| get_exponent
| Returns the exponent that controls the amount of light falloff from the center of the spotlight.
| get_max_distance
| Returns the maximum distance at which the light has any effect, as previously specified by set_max_distance.
| get_specular_color
| Returns the color of specular highlights generated by the light.
| set_attenuation
| Sets the terms of the attenuation equation for the light.
| set_exponent
| Sets the exponent that controls the amount of light falloff from the center of the spotlight.
| set_max_distance
| Sets the radius of the light's sphere of influence.
| set_specular_color
| Sets the color of specular highlights generated by the light.
Public Attributes inherited from LightLensNode
| get_shadow_buffer_size
| Returns the size of the shadow buffer to be created for this light source.
| is_shadow_caster
| Returns whether this light is configured to cast shadows or not.
| set_shadow_buffer_size
| Sets the size of the shadow buffer to be created for this light source.
Public Attributes inherited from Light
| get_color
| Returns the basic color of the light.
| get_color_temperature
| Returns the basic color temperature of the light, assuming has_color_temperature() returns true.
| get_priority
| Returns the priority associated with this light.
| set_color
| Sets the basic color of the light.
| set_color_temperature
| Sets the color temperature of the light in kelvins.
| set_priority
| Changes the relative importance of this light relative to the other lights that are applied simultaneously.
Public Attributes inherited from Camera
| clear_aux_scene_data
| Removes the AuxSceneData associated with the indicated NodePath.
| clear_tag_state
| Removes the association established by a previous call to set_tag_state().
| get_aux_scene_data
| Returns the AuxSceneData associated with the indicated NodePath, or NULL if nothing is associated.
| get_camera_mask
| Returns the set of bits that represent the subset of the scene graph the camera will render.
| get_cull_bounds
| Returns the custom cull volume that was set by set_cull_bounds(), if any, or NULL if no custom cull volume was set.
| get_cull_center
| Returns the point from which the culling operations will be performed, if it was set by set_cull_center(), or the empty NodePath otherwise.
| get_display_region
| Returns the nth display region associated with the camera.
| get_initial_state
| get_lod_center
| Returns the point from which the LOD distances will be measured, if it was set by set_lod_center(), or the empty NodePath otherwise.
| get_lod_scale
| Returns the multiplier for LOD distances.
| get_num_display_regions
| Returns the number of display regions associated with the camera.
| get_scene
| Returns the scene that will be rendered by the camera.
| get_tag_state
| Returns the state associated with the indicated tag state by a previous call to set_tag_state(), or the empty state if nothing has been associated.
| get_tag_state_key
| Returns the tag key as set by a previous call to set_tag_state_key().
| has_tag_state
| Returns true if set_tag_state() has previously been called with the indicated tag state, false otherwise.
| is_active
| Returns the current setting of the active flag on the camera.
| set_active
| Sets the active flag on the camera.
| set_aux_scene_data
| Associates the indicated AuxSceneData object with the given NodePath, possibly replacing a previous data defined for the same NodePath, if any.
| set_camera_mask
| Changes the set of bits that represent the subset of the scene graph the camera will render.
| set_cull_bounds
| Specifies the bounding volume that should be used to perform culling from this camera.
| set_cull_center
| Specifies the point from which the culling operations are performed.
| set_initial_state
| Sets the initial state which is applied to all nodes in the scene, as if it were set at the top of the scene graph.
| set_lod_center
| Specifies the point from which the LOD distances are measured.
| set_lod_scale
| Sets the multiplier for LOD distances.
| set_scene
| Sets the scene that will be rendered by the camera.
| set_tag_state
| Associates a particular state transition with the indicated tag value.
| set_tag_state_key
Public Attributes inherited from PandaNode
| clear_tag
| Removes the value defined for this key on this particular node.
| get_all_camera_mask
| Returns a DrawMask that is appropriate for rendering to all cameras.
| get_bounds_type
| Returns the bounding volume type set with set_bounds_type().
| get_child
| Returns the nth child node of this node.
| get_children
| Returns an object that can be used to walk through the list of children of the node.
| get_draw_control_mask
| Returns the set of bits in draw_show_mask that are considered meaningful.
| get_draw_show_mask
| Returns the hide/show bits of this particular node.
| get_effects
| get_internal_bounds
| Returns the node's internal bounding volume.
| get_internal_vertices
| Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.
| get_into_collide_mask
| Returns the "into" collide mask for this node.
| get_legal_collide_mask
| Returns the subset of CollideMask bits that may be set for this particular type of PandaNode.
| get_nested_vertices
| Returns the total number of vertices that will be rendered by this node and all of its descendents.
| get_num_children
| Returns the number of child nodes this node has.
| get_num_parents
| Returns the number of parent nodes this node has.
| get_num_stashed
| Returns the number of stashed nodes this node has.
| get_num_tags
| get_overall_bit
| get_parent
| Returns the nth parent node of this node.
| get_parents
| Returns an object that can be used to walk through the list of parents of the node, similar to get_children() and get_stashed().
| get_prev_transform
| get_python_tags
| get_stashed
| Returns the nth stashed child of this node.
| get_state
| get_tag
| get_tag_key
| get_transform
| has_tag
| is_bounds_stale
| is_final
| Returns the current state of the "final" flag.
| is_overall_hidden
| Returns true if the node has been hidden to all cameras by clearing its overall bit.
| set_bounds_type
| Specifies the desired type of bounding volume that will be created for this node.
| set_effects
| Sets the complete RenderEffects that will be applied this node.
| set_final
| set_into_collide_mask
| Sets the "into" CollideMask.
| set_overall_hidden
| Sets or clears the hidden flag.
| set_state
| Sets the complete RenderState that will be applied to all nodes at this level and below.
| set_tag
| Associates a user-defined value with a user-defined key which is stored on the node.
| set_transform
| Sets the transform that will be applied to this node and below.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name

## Additional Inherited Members
Public Types inherited from PandaNode
enum | FancyBits { FB_transform = 0x0001 , FB_state = 0x0002 , FB_effects = 0x0004 , FB_tag = 0x0010 , FB_draw_mask = 0x0020 , FB_cull_callback = 0x0040 }
typedef bool | SceneRootFunc(const PandaNode *)
enum | UnexpectedChange { UC_parents = 0x001 , UC_children = 0x002 , UC_transform = 0x004 , UC_state = 0x008 , UC_draw_mask = 0x010 }
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A light originating from a single point in space, and shining in a particular direction, with a cone-shaped falloff.

The Spotlight frustum is defined using a Lens, so it can have any of the properties that a camera lens can have.

Note that the class is named Spotlight instead of SpotLight, because "spotlight" is a single English word, instead of two words.

Definition at line 32 of file spotlight.h.

## Constructor & Destructor Documentation

## ◆ Spotlight()

Spotlight::Spotlight | ( | const std::string & | name | ) |

Definition at line 66 of file spotlight.cxx.

## Member Function Documentation

## ◆ bind()

void Spotlight::bind | ( | GraphicsStateGuardianBase * | gsg,
|  | const NodePath & | light,
|  | int | light_id )
| virtual

Implements Light.

Definition at line 205 of file spotlight.cxx.

## ◆ clear_specular_color()

void Spotlight::clear_specular_color | ( |  | ) |
| inline

Clears a custom specular color setting, meaning that the specular color will now come from the color.

Definition at line 90 of file spotlight.I.

Referenced by get_specular_color().

## ◆ force_init_type()

virtual TypeHandle Spotlight::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from LightLensNode.

Definition at line 124 of file spotlight.h.

## ◆ get_attenuation()

const LVecBase3 & Spotlight::get_attenuation | ( |  | ) | const
| inline final virtual

Returns the terms of the attenuation equation for the light.

These are, in order, the constant, linear, and quadratic terms based on the distance from the point to the vertex.

Reimplemented from Light.

References get_attenuation, and set_attenuation.

## ◆ get_class_priority()

int Spotlight::get_class_priority | ( |  | ) | const
| virtual

Returns the relative priority associated with all lights of this class.

This priority is used to order lights whose instance priority (get_priority()) is the same–the idea is that other things being equal, AmbientLights (for instance) are less important than DirectionalLights.

Implements Light.

Definition at line 197 of file spotlight.cxx.

## ◆ get_class_type()

static TypeHandle Spotlight::get_class_type | ( |  | ) |
| inline static

Definition at line 113 of file spotlight.h.

## ◆ get_exponent()

PN_stdfloat Spotlight::get_exponent | ( |  | ) | const
| inline final virtual

For spotlights, returns the exponent that controls the amount of light falloff from the center of the spotlight.

For other kinds of lights, returns 0.

Reimplemented from Light.

References set_exponent.

## ◆ get_specular_color()

const LColor & Spotlight::get_specular_color | ( |  | ) | const
| inline final virtual

Returns the color of specular highlights generated by the light.

This value is meaningless for ambient lights.

Reimplemented from Light.

References clear_specular_color(), get_specular_color, and set_specular_color.

## ◆ get_type()

virtual TypeHandle Spotlight::get_type | ( |  | ) | const
| inline virtual

Reimplemented from LightLensNode.

Definition at line 121 of file spotlight.h.

## ◆ get_vector_to_light()

bool Spotlight::get_vector_to_light | ( | LVector3 & | result,
|  | const LPoint3 & | from_object_point,
|  | const LMatrix4 & | to_object_space )
| virtual

Computes the vector from a particular vertex to this light.

The exact vector depends on the type of light (e.g. point lights return a different result than directional lights).

The input parameters are the vertex position in question, expressed in object space, and the matrix which converts from light space to object space. The result is expressed in object space.

The return value is true if the result is successful, or false if it cannot be computed (e.g. for an ambient light).

Reimplemented from Light.

Definition at line 143 of file spotlight.cxx.

## ◆ init_type()

static void Spotlight::init_type | ( |  | ) |
| inline static

Definition at line 116 of file spotlight.h.

## ◆ make_copy()

PandaNode * Spotlight::make_copy | ( |  | ) | const
| virtual

Returns a newly-allocated PandaNode that is a shallow copy of this one.

It will be a different pointer, but its internal data may or may not be shared with that of the original PandaNode. No children will be copied.

Reimplemented from Camera.

Definition at line 88 of file spotlight.cxx.

## ◆ register_with_read_factory()

void Spotlight::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type Spotlight.

Definition at line 241 of file spotlight.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

Referenced by init_libpgraphnodes().

## ◆ write()

void Spotlight::write | ( | std::ostream & | out,
|  | int | indent_level ) const
| virtual

Reimplemented from LightLensNode.

Definition at line 106 of file spotlight.cxx.

## ◆ write_datagram()

void Spotlight::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from LightLensNode.

Definition at line 250 of file spotlight.cxx.

References Datagram::add_bool(), BamWriter::get_file_minor_ver(), BamWriter::write_cdata(), and LightLensNode::write_datagram().

## ◆ xform()

void Spotlight::xform | ( | const LMatrix4 & | mat | ) |
| virtual

Transforms the contents of this PandaNode by the indicated matrix, if it means anything to do so.

For most kinds of PandaNodes, this does nothing.

Reimplemented from LensNode.

Definition at line 97 of file spotlight.cxx.

References LensNode::xform().

## Member Data Documentation

## ◆ bg

PN_stdfloat LColor LColor& Spotlight::bg

Definition at line 69 of file spotlight.h.

## ◆ fg

PN_stdfloat LColor& Spotlight::fg

Definition at line 69 of file spotlight.h.

## ◆ full_radius

PN_stdfloat Spotlight::full_radius

Definition at line 68 of file spotlight.h.

## ◆ get_attenuation

const LVecBase3 & Spotlight::get_attenuation
| inline

Returns the terms of the attenuation equation for the light.

These are, in order, the constant, linear, and quadratic terms based on the distance from the point to the vertex.

Definition at line 60 of file spotlight.h.

Referenced by DXGraphicsStateGuardian9::bind_light(), GraphicsStateGuardian::fetch_specified_part(), and get_attenuation().

## ◆ get_exponent

PN_stdfloat Spotlight::get_exponent
| inline

Returns the exponent that controls the amount of light falloff from the center of the spotlight.

See set_exponent().

Definition at line 51 of file spotlight.h.

Referenced by DXGraphicsStateGuardian9::bind_light(), and GraphicsStateGuardian::fetch_specified_part().

## ◆ get_max_distance

PN_stdfloat Spotlight::get_max_distance
| inline

Returns the maximum distance at which the light has any effect, as previously specified by set_max_distance.

Definition at line 64 of file spotlight.h.

## ◆ get_specular_color

const LColor & Spotlight::get_specular_color
| inline

Returns the color of specular highlights generated by the light.

This is usually the same as get_color().

Definition at line 56 of file spotlight.h.

Referenced by DXGraphicsStateGuardian9::bind_light(), GraphicsStateGuardian::fetch_specified_part(), and get_specular_color().

## ◆ set_attenuation

void Spotlight::set_attenuation
| inline

Sets the terms of the attenuation equation for the light.

These are, in order, the constant, linear, and quadratic terms based on the distance from the point to the vertex.

Definition at line 60 of file spotlight.h.

Referenced by get_attenuation().

## ◆ set_exponent

void Spotlight::set_exponent
| inline

Sets the exponent that controls the amount of light falloff from the center of the spotlight.

The light is attenuated by the cosine of the angle between the direction of the light and the direction of the point being lighted, raised to the power of this exponent. Thus, higher exponents result in a more focused light source, regardless of the field-of-view of the lens.

Definition at line 51 of file spotlight.h.

Referenced by get_exponent().

## ◆ set_max_distance

void Spotlight::set_max_distance
| inline

Sets the radius of the light's sphere of influence.

Beyond this distance, the light may be attenuated to zero, if this is supported by the shader.

Definition at line 64 of file spotlight.h.

## ◆ set_specular_color

void Spotlight::set_specular_color
| inline

Sets the color of specular highlights generated by the light.

Definition at line 56 of file spotlight.h.

Referenced by get_specular_color().

The documentation for this class was generated from the following files:

- panda/src/pgraphnodes/spotlight.h
- panda/src/pgraphnodes/spotlight.cxx
- panda/src/pgraphnodes/spotlight.I